package eu.mhsl.minecraft.pixelblocks;

import eu.mhsl.minecraft.pixelblocks.commands.ChessCommand;
import eu.mhsl.minecraft.pixelblocks.commands.CreatePixelBlockCommand;
import eu.mhsl.minecraft.pixelblocks.commands.ExitWorldCommand;
import eu.mhsl.minecraft.pixelblocks.listeners.*;
import org.bukkit.plugin.java.JavaPlugin;

import java.util.Objects;

public final class PixelBlocks extends JavaPlugin {
    public static PixelBlocks plugin;

    @Override
    public void onEnable() {
        PixelBlocks.plugin = this;
        this.getLogger().info("Hello World");
//        new File(plugin.getDataFolder().getPath()).mkdir();

        getServer().getPluginManager().registerEvents(new PlayerJumpListener(), this);
        getServer().getPluginManager().registerEvents(new PlayerInteractListener(), this);
        getServer().getPluginManager().registerEvents(new PlayerMoveListener(), this);
        getServer().getPluginManager().registerEvents(new EntityDamageListener(), this);
        getServer().getPluginManager().registerEvents(new BlockBreakListener(), this);
        getServer().getPluginManager().registerEvents(new BlockPlaceListener(), this);
        getServer().getPluginManager().registerEvents(new CreatureSpawnListener(), this);

        Objects.requireNonNull(getCommand("chess")).setExecutor(new ChessCommand());
        Objects.requireNonNull(getCommand("createpixelblock")).setExecutor(new CreatePixelBlockCommand());
        Objects.requireNonNull(getCommand("exitworld")).setExecutor(new ExitWorldCommand());
    }

}
