package eu.mhsl.minecraft.pixelblocks.commands;

import eu.mhsl.minecraft.pixelblocks.pixelblock.PixelBlock;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.NotNull;

import java.util.*;

public class ExitWorldCommand implements CommandExecutor {
    @Override
    public boolean onCommand(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) {
        if(sender instanceof Player p) {
            World playerWorld = p.getWorld();
            World[] standardWorlds = {Bukkit.getWorlds().get(0), Bukkit.getWorlds().get(1), Bukkit.getWorlds().get(2)};

            if(!Arrays.stream(standardWorlds).toList().contains(playerWorld)) {
                List<PixelBlock> ownedBlocks = PixelBlock.placedBlocks.stream()
                        .filter(pixelBlock -> pixelBlock.owner == p.getUniqueId())
                        .sorted(Comparator.comparing(pixelBlock -> pixelBlock.lastEntryTime))
                        .toList();

                Location newLocation;
                if(!ownedBlocks.isEmpty()) {
                    newLocation = ownedBlocks.getLast().lastEntryLocation;
                } else {
                    newLocation = Bukkit.getWorlds().getFirst().getSpawnLocation();
                }
                p.teleport(newLocation);
            } else {
                p.sendMessage("Dieser Command ist nur für PixelBlock Welten verfügbar!");
            }
        }

        return(true);
    }
}
