package eu.mhsl.minecraft.pixelblocks.listeners;

import eu.mhsl.minecraft.pixelblocks.PixelBlocks;
import eu.mhsl.minecraft.pixelblocks.pixelblock.Pixel;
import eu.mhsl.minecraft.pixelblocks.pixelblock.PixelBlock;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockBreakEvent;

import java.util.Arrays;
import java.util.List;

public class BlockBreakListener implements Listener {
    @EventHandler
    static void onBlockBreak(BlockBreakEvent event) {
        Location blockLocation = event.getBlock().getLocation();
        World[] standardWorlds = {Bukkit.getWorlds().get(0), Bukkit.getWorlds().get(1), Bukkit.getWorlds().get(2)};

        if(!Arrays.stream(standardWorlds).toList().contains(blockLocation.getWorld())) {
            Location spawnLocation = blockLocation.getWorld().getSpawnLocation();

            if(blockLocation.x() < spawnLocation.x() || blockLocation.z() < spawnLocation.z() || blockLocation.y() < spawnLocation.y()-1) {
                event.setCancelled(true);
                return;
            } else if(blockLocation.x() > spawnLocation.x()+15 || blockLocation.z() > spawnLocation.z()+15 || blockLocation.y() > spawnLocation.y()+14) {
                event.setCancelled(true);
                return;
            }

            Bukkit.getScheduler().runTask(PixelBlocks.plugin, () -> {
                String blockUUID = Arrays.stream(blockLocation.getWorld().getName().split("/")).toList().getLast();
                List<PixelBlock> pixelBlocks = PixelBlock.placedBlocks.stream().filter(block -> block.uuid.toString().equals(blockUUID)).toList();

                if(!pixelBlocks.isEmpty()) {
                    PixelBlock pixelBlock = pixelBlocks.getFirst();
                    Location relativeLocation = blockLocation.subtract(spawnLocation.x(), spawnLocation.y()-1, spawnLocation.z());
                    relativeLocation.setWorld(pixelBlock.pixelBlockLocation.getWorld());
                    List<Pixel> pixels = pixelBlock.pixels.stream().filter(pixel -> pixel.relativeLocation.equals(relativeLocation)).toList();

                    if(!pixels.isEmpty()) {
                        Pixel pixel = pixels.getFirst();
                        pixel.remove();
                        pixelBlock.pixels.remove(pixel);
                    }
                }
            });
        }
    }
}
