package eu.mhsl.minecraft.pixelblocks.pixelblock;

import org.bukkit.Location;
import org.bukkit.block.data.BlockData;
import org.bukkit.entity.BlockDisplay;
import org.bukkit.entity.Entity;
import org.bukkit.entity.EntityType;
import org.bukkit.util.Transformation;

import java.util.UUID;

public class Pixel {
    public Location relativeLocation;
    public BlockData blockData;
    double scale;
    double offset;

    public UUID uuid;

    public Pixel(Location relativeLocation, BlockData blockData, double scale, double offset) {
        this.relativeLocation = new Location(
            relativeLocation.getWorld(),
            relativeLocation.x(),
            relativeLocation.y(),
            relativeLocation.z()
        );
        this.blockData = blockData;
        this.scale = scale;
        this.offset = offset;
    }

    public void spawn(Location spawnBlockLocation) {
        double positionX = spawnBlockLocation.x()+relativeLocation.x()*scale+offset;
        double positionY = spawnBlockLocation.y()+relativeLocation.y()*scale+offset;
        double positionZ = spawnBlockLocation.z()+relativeLocation.z()*scale+offset;

        Location spawnLocation = new Location(spawnBlockLocation.getWorld(), positionX, positionY, positionZ);

        BlockDisplay bd = (BlockDisplay) spawnLocation.getWorld().spawnEntity(
            spawnLocation,
            EntityType.BLOCK_DISPLAY
        );

        bd.setBlock(blockData);

        Transformation transform = bd.getTransformation();
        transform.getScale().set(scale);
        bd.setTransformation(transform);

        this.uuid = bd.getUniqueId();
    }

    public void remove() {
        Entity pixelEntity = this.relativeLocation.getWorld().getEntity(this.uuid);
        if(pixelEntity != null) pixelEntity.remove();
    }
}
